function Hss=anulass(Hss,tol,modo);
% H = mi_minreal(H, tol, modo);
%
% Si modo='abs': Hace cero entradas en matrices A,B,C,D de H que sean
% menores a tol y luego se aplica minreal.
%
% Si modo='rel':  Hace cero entradas en matrices A,B,C,D de H que sean menores a tol *
% maximo valor de cada matriz y luego se aplica minreal.
%
% Si se omite tol, se usa tol = 1e-10.
% Si se omite modo, se usa modo='abs'.
%
% H es LTI y puede ser discreto o continuo, ss, tf o zpk. Se trabaja en ss y se devuelve ss.
%
% Para matrices impropias, usar anulatf
%

if nargin==1
    tol=1e-10;
    modo='rel';
elseif nargin==2
    modo='rel';
elseif nargin==3 & ( modo~='abs' & modo~='rel' )
    error('Tercer argumento es "abs" o "rel" (comillas simples) !');
end

Hss=minreal(ss(Hss));

if modo=='rel'

    Hss=minreal(ss(  anula(Hss.a,tol*max(max(abs(Hss.a)))) , anula(Hss.b,tol*max(max(abs(Hss.b)))), anula(Hss.c,tol*max(max(abs(Hss.c)))),...
        anula(Hss.d,tol*max(max(abs(Hss.d)))), Hss.Ts));
    
else

    Hss=minreal(ss(  anula(Hss.a,tol) , anula(Hss.b,tol), anula(Hss.c,tol), anula(Hss.d,tol), Hss.Ts));

end
