function [To, So, Suo, Sio, SuoGo]=calc_sensibilidades(Go,C)
% [T, S, Su, Si, SuG]=calc_sensibilidades(G,C);
%
% Dadas G y C funciones de transferencia (tf, zpk)
% devuelve las funciones de sensibilidad (en MIMO SuG ~= T) de lazo
% asociado.
%

Go=minreal(ss(Go));
C= minreal(ss(C ));

So=anulass( minreal(( inv( eye(size(Go)) + Go*C)), 1e-7), 1e-10, 'rel') ;
To=anulass( minreal(eye(size(Go)) - So , 1e-7)  , 1e-10, 'rel');
Suo=ss(minreal(zpk(anulass( minreal(C*So , 1e-7), 1e-10, 'rel')), 1e-5));
Sio=anulass(minreal(So*Go, 1e-7), 1e-10, 'rel');
SuoGo=anulass(minreal(Suo*Go, 1e-7), 1e-10, 'rel');

if Go.Ts==0

    re_polos = real( [pole(So);pole(To),;pole(Suo);pole(Sio);pole(SuoGo)] );

    if max(re_polos)> 0
        warning('Controlador NO estabiliza');
    end

else

    abs_polos=abs([pole(So);pole(To),;pole(Suo);pole(Sio);pole(SuoGo)]);

    if max(abs_polos)>=1
        warning('Controlador NO estabiliza');
    end

end
