function C = pole_assign(Go, ctrl_poles, cl_poles)
% C = pole_assign(Go, ctrl_poles, cl_poles);
%
% Programado por Juan Yuz, 2011.
%

[B, A] = tfdata(Go, 'v');

n=size(A,2)-1;
m=size(B,2)-1;
r=n-m; % grado relativo

%% Polos de lazo cerrado

% polinomio de lazo cerrado dado
Acl=poly(cl_poles);
ncl=size(Acl,2)-1;

%% Polos dados del controlador
Lg=poly(ctrl_poles);
r=size(Lg,2)-1;

% revisamos si los grados son adecuados

if (ncl<2*n-1+r),
    disp('Error, no existe controlador!');
    C = [];
    return;
else
    %disp('Existe un controlador!');
    n_c=ncl-n;
    n_P=n_c; %orden de P(z): n_P+1 grados de libertad
    n_Lt=n_c-r; % orden de L_tilde,
%     disp(['Grado de Acl(z) = ',num2str(ncl)]);
%     disp(['Grado de P(z) = ',num2str(n_P)]);
%     disp(['Grado de \bar L(z) = ',num2str(n_Lt)]);
%     disp(['Parametros a disear = ',num2str(n_P+n_Lt+1)]);
end

% restricciones de la ecuacion diofantina Aeq x = beq
a_tilde=conv(A,Lg);
b_tilde=B;

Aeq=zeros(ncl+1,n_Lt+1+n_P+1);
beq=Acl';

for ii=1:n_Lt+1,
    Aeq(ii:ii+ncl-n_Lt,ii)=a_tilde';
end

for ii=n_Lt+2:n_Lt+1+n_P+1,
    Aeq(ii-(n_Lt+n_P+2)+ncl+1-m:ii-(n_Lt+n_P+2)+ncl+1,ii)=b_tilde';
end

[x1, fval, exit] = quadprog( eye(size(Aeq,1)), zeros(size(Aeq,1),1), zeros(size(Aeq)), zeros(size(Aeq,1),1), Aeq, beq);

if exit<=0
    disp('No se pudo resolver')
    C = [];
else
    C=minreal(ss(tf(x1(n_Lt+2:n_Lt+n_P+2)',conv(Lg,x1(1:n_Lt+1)'))));
end

